// bot5.c
// SilentBot
// 24.03.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <sys/wait.h>

#define TEMP_PATH "/eizm/tmp/t1i/bot5."
#define LOG_PATH "/eizm/log/t1i/bot5.log"
#define WAIT_PATH "/eizm/mem/t1i/mpost/"
#define SENT_PATH "/eizm/mem/t1i/mpost/sent/"
#define TEMPFILE_PATH "/eizm/tmp/t1i/bot5temp"
#define POSTDATA_PATH "/eizm/tmp/t1i/bot5post"
#define COOKIE_PATH "/eizm/tmp/t1i/bot5cook"
#define STOP_PATH "/eizm/tmp/t1i/bot5stop"
#define LS_PATH "/bin/ls"
#define MV_PATH "/bin/mv"
#define RM_PATH "/bin/rm"
#define MAWK_PATH "/usr/bin/mawk"
#define WGET_PATH "/usr/bin/wget"
#define AWK_POST "/eizm/pro/t1i/post.awk"
#define AWK_MPOST "/eizm/pro/t1i/mpost.awk"
#define AWK_LASTPOST "/eizm/pro/t1i/lastpost.awk"
#define PWAIT 15
#define LASTPOST_ADDRESS "http://forums.xkcd.com/viewtopic.php?f=7&t=101043&sd=d"
#define USERAGENT "SilentBot (http://1190.bicyclesonthemoon.info/silentbot/; the Silent Chronotransponder bot)"

pid_t sub;
int r;

int main(int argc, char **argv)
{
	time_t t;
	struct tm *nowS;
	int yarg;
	unsigned char text=0;
	unsigned char newlog=0;
	FILE *list;
	FILE *post;
	FILE *stopfile;
	char temppath[256];
	unsigned char logopen=0;
	unsigned char i;
	char line[256];
	char value[256];
	char inpath[256];
	char outpath[256];
	char argp1[256];
	char argp2[256];
	char argp3[256];
	char argp4[256];
	char argp5[256];
	unsigned char d,m,h;
	unsigned short y;
	unsigned char another=0;
	unsigned char edit;
	
	t=time(NULL);
	sprintf(temppath,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	
	while((yarg = getopt(argc,argv,"tn")) != -1)
	{
		switch(yarg)
		{
		case 't':
			text=1;
			break;
		case 'n':
			newlog=1;
			break;
		default:
			
			break;
		}
	}
	if(!text)
	{
		if(freopen(LOG_PATH,newlog?"wt":"at",stdout)!=NULL)
			logopen=1;
	}
	setvbuf(stdout, NULL, _IONBF, 0);
	dup2(fileno(stdout),fileno(stderr));
	printf("\n%s",ctime(&t));
	
	stopfile=fopen(STOP_PATH,"wt");
	if (stopfile==NULL)
	{
		printf("FULL STOPFULL STOP\n");
		return 1;
	}
	if (lockf(fileno(stopfile),F_TLOCK,0)!=0)
	{
		printf("FULL STOPFULL STOP\n");
		return 1;
	}
	fprintf(stopfile,"%hu.FULL STOPFULL STOP\n",0);
	
	
	sub=fork();
	if(sub==0)
	{
		if(freopen(temppath,"wt",stdout)==NULL)
			exit(255);
		r=execl(LS_PATH,LS_PATH,"-1","--color=never",WAIT_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("ls fail.\n");
	else
	{
		list=fopen(temppath,"rt");
		if(list==NULL)
			printf("list fail.\n");
		else
		{
			for(i=0; fgets(line,255,list)!=NULL; ++i)
			{
			sscanf(line,"%s",value);
				if(value[0]>'9'||value[0]<'0')
				{
					--i;
					continue;
				}
				printf("%s",value);
				sprintf(inpath,"%s%s",WAIT_PATH,value);
				post=fopen(inpath,"rt");
				if(post==NULL)
				{
					printf(" fail.\n");
					continue;
				}
				for(h=0xff,d=0xff,m=0xff,y=0xffff;fgets(line,31,post)!=NULL;)
				{
					if(line[strlen(line)-1]!='\n')
						continue;
					if(line[0]=='h'&&line[1]=='=')
					{
						sscanf(line+2,"%hhu",&h);
						//printf("\n h%hhu d%hhu %s",h,d,line);
					}
					else if(line[0]=='d'&&line[1]=='=')
					{
						sscanf(line+2,"%hhu",&d);
						//printf("\n d%hhu d%hhu %s",d,d,line);
					}
					else if(line[0]=='m'&&line[1]=='=')
					{
						sscanf(line+2,"%hhu",&m);
						//printf("\n m%hhu d%hhu %s",m,d,line);
					}
					else if(line[0]=='y'&&line[1]=='=')
					{
						sscanf(line+2,"%hu",&y);
						//printf("\n y%hu d%hhu %s",y,d,line);
					}
				}
				fclose(post);
				printf(" %02hhu.%02hhu.%04hu %02hhu:00",d,m,y,h);
				nowS=gmtime(&t);
				
				if((1900+nowS->tm_year-y)>=2)
				{
					printf(" timer mustard");
					continue;
				}
				
				if(y>1900+nowS->tm_year)
				{
					printf(" wait\n");
					continue;
				}
				else if(y==1900+nowS->tm_year)
				{
					if(m>1+nowS->tm_mon)
					{
						printf(" wait\n");
						continue;
					}
					else if(m==1+nowS->tm_mon)
					{
						if(d>nowS->tm_mday)
						{
							printf(" wait\n");
							continue;
						}
						else if(d==nowS->tm_mday)
						{
							if(h>nowS->tm_hour)
							{
								printf(" wait\n");
								continue;
							}
						}
						
					}
				}
				
				printf(" deliver");
				
				do
				{//test latest post
					edit=0;
					sub=fork();
					if(sub==0)
					{
						r=execl(WGET_PATH,WGET_PATH, "-q","-t", "3","-U", USERAGENT, "-O", TEMPFILE_PATH,LASTPOST_ADDRESS, (char *)0);
						exit(r);
					}
					waitpid(sub,&r,0);
					if(r)
						break;
					
					sub=fork();
					if(sub==0)
					{
						if(freopen(temppath,"wt",stdout)==NULL)
							exit(255);
						r=execl(MAWK_PATH,MAWK_PATH, "-f",AWK_LASTPOST, TEMPFILE_PATH, (char *)0);
						exit(r);
					}
					waitpid(sub,&r,0);
					if(r)
						break;
					
					post=fopen(temppath,"rt");
					if(post==NULL)
						break;
						
					if(fgets(argp1,255,post)!=NULL)
					{
						sscanf(argp1,"%s",argp2);
						sprintf(argp4,"edit=%s",argp2);
					}
					else
					{
						fclose(post);
						break;
					}
					if(fgets(argp1,255,post)!=NULL)
					{
						sscanf(argp1,"%s",argp2);
						sprintf(argp5,"user=%s",argp2);
					}
					else
					{
						fclose(post);
						break;
					}
					fclose(post);
					edit=1;
				}while(0);
				
				sprintf(argp1 ,"postfile=%s",POSTDATA_PATH);
				sprintf(argp2,"cookiefile=%s",COOKIE_PATH);
				sprintf(argp3,"tempfile=%s",TEMPFILE_PATH);
				// sprintf(argp4,"name=%s",name);
				// sprintf(argp5,"pass=%s",pass);
				
				//no longer necessary - bot can now edit
				//ETA: not true, still have to wait but only 15s - so that phpBB doesn't
				if(another)
					sleep(PWAIT);
				
				sprintf(outpath,"%s%s",SENT_PATH,value);
				
				sub=fork();
				if(sub==0)
				{
					r=execl(MV_PATH,MV_PATH,inpath,outpath,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				if(r)
					printf(" mv fail.\n");
				
				sub=fork();
				if(!sub)
				{
					if(edit)
						r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_POST,"-v",argp1,"-v",argp2,"-v",argp3,"-v",argp4,"-v",argp5,outpath,(char *)0);
					else
						r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_POST,"-v",argp1,"-v",argp2,"-v",argp3,outpath,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				if(r)
				{
					sub=fork();
					if(!sub)
					{
						r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_MPOST,"-v",argp1,"-v",argp2,"-v",argp3,outpath,(char *)0);
						exit(r);
					}
					waitpid(sub,&r,0);
					if(r)
					{
						another=0;
						continue;
					}
				}
				else
				{
					post=fopen(POSTDATA_PATH,"rt");
					if(post!=NULL)
					{
						if(fgets(line,255,post)!=NULL)
						{
							sscanf(line,"%s",value);
							fclose(post);
							
							post=fopen(outpath,"at");
							if(post!=NULL)
							{
								fprintf(post,"ID=%s\n",value);
								fclose (post);
							}
						}
						else
							fclose(post);
					}
				
				}
				printf(" ok\n");
				another=1;
				
			}
			
			if(i==0)
				printf("Nothing.\n");
			fclose(list);
			sub=fork();
			if(sub==0)
			{
				r=execl(RM_PATH,RM_PATH,"-f",temppath,(char *)0);
				exit(r);
			}
			waitpid(sub,&r,0);
			if(r)
				printf("rm fail.\n");
			
			
				sub=fork();
				if(!sub)
				{
					r=execl(RM_PATH,RM_PATH,"-f",COOKIE_PATH,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				sub=fork();
				if(!sub)
				{
					r=execl(RM_PATH,RM_PATH,"-f",POSTDATA_PATH,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				sub=fork();
				if(!sub)
				{
					r=execl(RM_PATH,RM_PATH,"-f",TEMPFILE_PATH,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				
				lockf(fileno(stopfile),F_ULOCK,0);
				fclose(stopfile);
				
				sub=fork();
				if(!sub)
				{
					r=execl(RM_PATH,RM_PATH,"-f",STOP_PATH,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
		}
	}
	if(logopen)
		fclose(stdout);
	return 0;
}
