// upload.c (1190.bicyclesonthemoon.info/silentbot/upload)
// The post upload interface
// 28.03.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define RM_PATH "/bin/rm"
#define MAWK_PATH "/usr/bin/mawk"
#define AWK_UPLOAD "/eizm/pro/t1i/upload.awk"
#define TEMP_PATH "/eizm/tmp/t1i/upload."
#define RM_PATH "/bin/rm"

s_cgi *cgi;
pid_t sub;
int r;

int main(int argc, char **argv)
{
	char *temppath;
	char **up;
	time_t posttime;
	struct tm *nowS;
	char timetext[64];
	char timenumber[64];
	char temppath2[247];
	char temppath3[256];
	
	setvbuf(stdout, NULL, _IONBF, 0);
	dup2(fileno(stdout),fileno(stderr));
	
	cgi=cgiInit();
	
	sprintf(temppath2,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	sprintf(temppath3,"tempfile=%s",temppath2);
	
	printf("Content-type: text\n\n");
	up=cgiGetFiles(cgi);
	if (up)
	{
		temppath=cgiGetFile(cgi,up[0])->tmpfile;
		
		posttime=time(NULL);
		nowS=gmtime(&posttime);
		
		sprintf(timenumber,"timenumber=%lu",(unsigned long)posttime);
		sprintf(timetext,"timetext=%04d%02d%02d%02d",nowS->tm_year+1900,nowS->tm_mon+1,nowS->tm_mday,nowS->tm_hour);
		
		// printf("%s\n%s\n%s\n",timenumber,timetext,temppath);
		
		sub=fork();
		if(!sub)
		{
			r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_UPLOAD,"-v",timetext,"-v",timenumber,"-v",temppath3,temppath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		
		sub=fork();
		if(!sub)
		{
			r=execl(RM_PATH,RM_PATH,"-f",temppath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		sub=fork();
		if(!sub)
		{
			r=execl(RM_PATH,RM_PATH,"-f",temppath2,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		
		return 0;
	}
	printf("File missing\n");
	return 0;
}
